"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.ts
var index_exports = {};
__export(index_exports, {
  AccountStatus: () => AccountStatus,
  CoBranding: () => CoBranding,
  createAccount: () => createAccount4,
  createAccountForMyUser: () => createAccountForMyUser4,
  listChildAccounts: () => listChildAccounts4
});
module.exports = __toCommonJS(index_exports);

// src/identity-account-v2-account-accounts.universal.ts
var import_transform_error = require("@wix/sdk-runtime/transform-error");
var import_rename_all_nested_keys = require("@wix/sdk-runtime/rename-all-nested-keys");

// src/identity-account-v2-account-accounts.http.ts
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules2 = require("@wix/sdk-runtime/rest-modules");
function resolveComWixpressAccountApiAccountServiceUrl(opts) {
  const domainToMappings = {
    "api._api_base_domain_": [
      {
        srcPath: "/account-server",
        destPath: ""
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/account-server",
        destPath: ""
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/account-server",
        destPath: ""
      },
      {
        srcPath: "/account-server",
        destPath: ""
      }
    ],
    "premium._base_domain_": [
      {
        srcPath: "/_api/account-server",
        destPath: ""
      }
    ],
    "editor._base_domain_": [
      {
        srcPath: "/_api/account-server",
        destPath: ""
      }
    ],
    "blocks._base_domain_": [
      {
        srcPath: "/_api/account-server",
        destPath: ""
      }
    ],
    "create.editorx": [
      {
        srcPath: "/_api/account-server",
        destPath: ""
      }
    ],
    "bo._base_domain_": [
      {
        srcPath: "/account-server",
        destPath: ""
      }
    ],
    "wixbo.ai": [
      {
        srcPath: "/account-server",
        destPath: ""
      }
    ],
    "wix-bo.com": [
      {
        srcPath: "/account-server",
        destPath: ""
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/accounts",
        destPath: ""
      },
      {
        srcPath: "/accounts/v1/accounts",
        destPath: "/v1/accounts"
      },
      {
        srcPath: "/accounts/v1/account",
        destPath: "/v1/account"
      }
    ],
    "users._base_domain_": [
      {
        srcPath: "/_api/account-server",
        destPath: ""
      }
    ],
    "*.dev.wix-code.com": [
      {
        srcPath: "/_api/account-server",
        destPath: ""
      }
    ],
    "twins._base_domain_": [
      {
        srcPath: "/_api/account-server",
        destPath: ""
      }
    ]
  };
  return (0, import_rest_modules2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_user-management_accounts";
function createAccount(payload) {
  function __createAccount({ host }) {
    const metadata = {
      entityFqdn: "wix.identity.account.v2.account",
      method: "POST",
      methodFqn: "com.wixpress.account.api.AccountService.createAccount",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressAccountApiAccountServiceUrl({
        protoPath: "/v1/accounts/create",
        data: payload,
        host
      }),
      data: payload
    };
    return metadata;
  }
  return __createAccount;
}
function createAccountForMyUser(payload) {
  function __createAccountForMyUser({ host }) {
    const metadata = {
      entityFqdn: "wix.identity.account.v2.account",
      method: "POST",
      methodFqn: "com.wixpress.account.api.AccountService.createAccountForMyUser",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressAccountApiAccountServiceUrl({
        protoPath: "/v1/accounts",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "account.dateCreated" },
            { path: "account.dateUpdated" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __createAccountForMyUser;
}
function listChildAccounts(payload) {
  function __listChildAccounts({ host }) {
    const metadata = {
      entityFqdn: "wix.identity.account.v2.account",
      method: "GET",
      methodFqn: "com.wixpress.account.api.AccountService.listChildAccounts",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressAccountApiAccountServiceUrl({
        protoPath: "/v1/account/child-accounts",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload)
    };
    return metadata;
  }
  return __listChildAccounts;
}

// src/identity-account-v2-account-accounts.universal.ts
var AccountStatus = /* @__PURE__ */ ((AccountStatus2) => {
  AccountStatus2["ACTIVE"] = "ACTIVE";
  AccountStatus2["BLOCKED"] = "BLOCKED";
  AccountStatus2["DELETED"] = "DELETED";
  return AccountStatus2;
})(AccountStatus || {});
var CoBranding = /* @__PURE__ */ ((CoBranding2) => {
  CoBranding2["None"] = "None";
  CoBranding2["CoBranded"] = "CoBranded";
  CoBranding2["CoBranded_Customer_New"] = "CoBranded_Customer_New";
  CoBranding2["CoBranded_Customer_Existing"] = "CoBranded_Customer_Existing";
  return CoBranding2;
})(CoBranding || {});
async function createAccount2(user, options) {
  const { httpClient, sideEffects } = arguments[2];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    user,
    roles: options?.roles
  });
  const reqOpts = createAccount(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { user: "$[0]", roles: "$[1].roles" },
        singleArgumentUnchanged: false
      },
      ["user", "options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function createAccountForMyUser2(options) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    accountName: options?.accountName,
    accountImg: options?.accountImg,
    studio: options?.studio
  });
  const reqOpts = createAccountForMyUser(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          accountName: "$[0].accountName",
          accountImg: "$[0].accountImg",
          studio: "$[0].studio"
        },
        singleArgumentUnchanged: false
      },
      ["options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function listChildAccounts2(options) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    paging: options?.paging
  });
  const reqOpts = listChildAccounts(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { paging: "$[0].paging" },
        singleArgumentUnchanged: false
      },
      ["options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}

// src/identity-account-v2-account-accounts.public.ts
function createAccount3(httpClient) {
  return (user, options) => createAccount2(
    user,
    options,
    // @ts-ignore
    { httpClient }
  );
}
function createAccountForMyUser3(httpClient) {
  return (options) => createAccountForMyUser2(
    options,
    // @ts-ignore
    { httpClient }
  );
}
function listChildAccounts3(httpClient) {
  return (options) => listChildAccounts2(
    options,
    // @ts-ignore
    { httpClient }
  );
}

// src/identity-account-v2-account-accounts.context.ts
var import_rest_modules3 = require("@wix/sdk-runtime/rest-modules");
var createAccount4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(createAccount3);
var createAccountForMyUser4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(createAccountForMyUser3);
var listChildAccounts4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(listChildAccounts3);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AccountStatus,
  CoBranding,
  createAccount,
  createAccountForMyUser,
  listChildAccounts
});
//# sourceMappingURL=index.js.map